#include "GoalReachedMonitor.h"

#include <VirtualRobot/Robot.h>

#include <ArmarXCore/core/exceptions/local/ExpressionException.h>
#include <ArmarXCore/core/logging/Logging.h>


namespace armarx::navigation::server
{

    GoalReachedMonitor::GoalReachedMonitor(const std::vector<core::Pose>& waypoints,
                                           const core::Scene& scene,
                                           const GoalReachedMonitorConfig& config) :
        waypoints(waypoints), scene(scene), config(config)
    {
        ARMARX_CHECK(not waypoints.empty());
    }

    bool
    GoalReachedMonitor::goalReached() const noexcept
    {
        // FIXME remove
        return false;

        const core::Pose world_T_robot(scene.robot->getGlobalPose());
        const core::Pose& world_T_goal(waypoints.back());

        const core::Pose robot_T_goal = world_T_robot.inverse() * world_T_goal;

        const bool posReached = robot_T_goal.translation().norm() <= config.posTh;
        const bool oriReached = Eigen::AngleAxisf(robot_T_goal.linear()).angle() <= config.oriTh;

        if (posReached)
        {
            ARMARX_INFO << "posReached";
        }

        if (oriReached)
        {
            ARMARX_INFO << "oriReached";
        }


        return posReached and oriReached;
    }

    GoalReachedMonitor::GoalReachedMonitor(GoalReachedMonitor&& other) noexcept :
        waypoints{other.waypoints}, scene{other.scene}, config(other.config)
    {
    }
    GoalReachedMonitor&
    GoalReachedMonitor::operator=(GoalReachedMonitor&& /*unused*/) noexcept
    {
        return *this;
    }
} // namespace armarx::navigation::server
